/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: com.microsoft.sqlserver.jdbc.SQLServerDriver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 17/07/2019
 --------------------------------------------------------
*/
package com.portofolio.entity;

import  static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;
import  javax.persistence.*;
import  javax.validation.constraints.*;
import com.portofolio.entity.vo.MapRuanganLoginToRuanganPId;
import  lombok.AllArgsConstructor;
import  lombok.Getter;
import  lombok.NoArgsConstructor;
import  lombok.Setter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;


@Entity
@Table(name = "MapRuanganLoginToRuanganP_M",indexes = {@Index(name = "MapRuanganLoginToRuanganP_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class MapRuanganLoginToRuanganP {
    
    @EmbeddedId
    private MapRuanganLoginToRuanganPId id ;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "mapruanganlogintoruanganp.statusenabled.notnull")
    private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "mapruanganlogintoruanganp.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "mapruanganlogintoruanganp.version.notnull")
    private Integer version;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdRuanganLogin", referencedColumnName="KdRuangan",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
     private Ruangan ruanganLogin;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdRuanganPelayanan", referencedColumnName="KdRuangan",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
     private Ruangan ruanganPelayanan;
    

}
